//
//  BCPressureSensor.m
//  ANTDemo
//
//  Created by Umeno Katsuhiko on 13/06/12.
//  Copyright (c) 2013年 Umeno Katsuhiko. All rights reserved.
//

#import "BCPressureSensor.h"

NSString* const BCPressureSensorUpdate = @"BCPressureSensorUpdate";

#define PRESS_DEVICE_TYPE    0
#define PRESS_PERIOD         0.5     // Hz
#define PRESS_FREQ           2467    // Mhz

@implementation BCPressureSensor

@synthesize pressure = _pressure;

-(id) initWithChannelNumber:(UInt8)channel
{
    self = [super initWithChannelNumber:channel];
    if (self) {
        // HumiditySensor Setting
        self.deviceType = PRESS_DEVICE_TYPE;
        self.period = 32768 / PRESS_PERIOD;
        self.frequency = PRESS_FREQ - 2400;
    }
    
    return self;
}

// Override from SennsorCommon
- (void) didBroadcastDataReceive:(UInt8*)data length:(UInt8)length
{
    [super didBroadcastDataReceive:data length:length];
    NSLog(@"PressureSensor:didBroadcastDataReceive length=%u",length);
    
    //NSData* d = [NSData dataWithBytes:data length:length];
    //NSLog(@"%@",d);
    
    NSInteger press = (data[5] << 24) | (data[4] << 16) | (data[3] << 8) | data[2];
    _pressure = (double)press / 100.0;
    NSLog(@"Press:%f",_pressure);
    
    NSNotification* notify = [NSNotification notificationWithName:BCPressureSensorUpdate object:self];
    [[NSNotificationCenter defaultCenter] postNotification:notify];
}

@end
