//
//  BCANTResponseEvent.h
//  ANT_TEST
//
//  Created by Umeno Katsuhiko on 12/08/21.
//  Copyright (c) 2012 BeatCraft,Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "antheader/antmessage.h"
//#import "pthread.h"

@interface BCANTResponse : NSObject
{
    UInt8           msgID;
    UInt8           length;
    UInt8           data[MESG_MAX_SIZE_VALUE];
}
@property(nonatomic) UInt8 msgID;
@property(nonatomic) UInt8 length;
//@property(nonatomic) UInt8* data;

- (id) initWithData:(UInt8)ID data:(UInt8*)d length:(UInt8)len;

@end

@interface BCANTChannelResponse : BCANTResponse
{
    UInt8           channel;
    UInt8           messageID;
    UInt8           messageCode;
}
@property(nonatomic) UInt8 channel;
@property(nonatomic) UInt8 messageID;
@property(nonatomic) UInt8 messageCode;

- (id) initWithData:(UInt8)ID data:(UInt8*)d length:(UInt8)len;

@end

@interface BCANTChannelStatus : BCANTResponse
{
    UInt8           channel;
    UInt8           channelType;
    UInt8           networkNumber;
    UInt8           status;
}
@property(nonatomic) UInt8 channel;
@property(nonatomic) UInt8 channelType;
@property(nonatomic) UInt8 networkNumber;
@property(nonatomic) UInt8 status;

- (id) initWithData:(UInt8)ID data:(UInt8*)d length:(UInt8)len;

@end

@interface BCANTChannelID : BCANTResponse
{
    UInt8           channel;
    UInt16          deviceNumber;
    UInt8           deviceType;
    UInt8           transmissionType;
}
@property(nonatomic) UInt8 channel;
@property(nonatomic) UInt16 deviceNumber;
@property(nonatomic) UInt8 deviceType;
@property(nonatomic) UInt8 transmissionType;

- (id) initWithData:(UInt8)ID data:(UInt8*)d length:(UInt8)len;

@end

@interface BCANTVersion : BCANTResponse
{
    NSString*       version;
}
@property (nonatomic, readonly, strong) NSString* version;

- (id) initWithData:(UInt8)ID data:(UInt8*)d length:(UInt8)len;

@end

@interface BCANTCapabilities : BCANTResponse
{
    UInt8           maxChannels;
    UInt8           maxNetworks;
    UInt8           standerdOptions;
    UInt8           advancedOptions;
    UInt8           advancedOptions2;
}
@property(nonatomic) UInt8 maxChannels;
@property(nonatomic) UInt8 maxNetworks;
@property(nonatomic) UInt8 standerdOptions;
@property(nonatomic) UInt8 advancedOptions;
@property(nonatomic) UInt8 advancedOptions2;

- (id) initWithData:(UInt8)ID data:(UInt8*)d length:(UInt8)len;

@end

@interface BCANTSerialNumber : BCANTResponse
{
    UInt32         serialNumber;
}
@property(nonatomic) UInt32 serialNumber;

- (id) initWithData:(UInt8)ID data:(UInt8*)d length:(UInt8)len;

@end







